LTTng-tools - Feature #555

add-context --help lists perf fields even when the machine has no generic registers at all
Description
This was taken from a machine running 3.2.0-40-virtual:

$ lttng add-context —--help
usage: lttng add-context -t TYPE [-k|-u] [OPTIONS]
[...]

Context:

-t, ——type TYPE Context type. You can repeat that option on

the command line to specify multiple
(——kernel preempts —--userspace)

TYPE can be one of the strings below:

pid, procname, prio, nice, vpid,

contexts at once.

tid, pthread_id,

vtid, ppid, vppid, hostname, perf:cpu-cycles,

perf:cycles, perf:stalled-cycles-—

perf:idle-cycles—-frontend,
perf:stalled-cycles-backend,

frontend,

perf:idle-cycles-backend, perf:instructions,
perf:cache-references, perf:cache-misses,
perf:branch-instructions, perf:branches,

perf:branch-misses, perf:bus-cycles,
perf:Ll-dcache-loads, perf:Ll-dcache-load-misses,

perf:Ll-dcache-stores,
perf:Ll-dcache-store-misses,
perf:Ll-dcache-prefetches,
perf:Ll-dcache-prefetch-misses,

perf:Ll-icache-loads, perf:Ll-icache-load-misses,

perf:Ll-icache-stores,
perf:Ll-icache-store-misses,
perf:Ll-icache-prefetches,

perf:Ll-icache-prefetch-misses, perf:LLC-loads,
perf:LLC-load-misses, perf:LLC-stores,
perf:LLC-store-misses, perf:LLC-prefetches,
perf:LLC-prefetch-misses, perf:dTLB-loads,

perf:dTLB-load-misses, perf:dTLB-

stores,

perf:dTLB-store-misses, perf:dTLB-prefetches,
perf:dTLB-prefetch-misses, perf:iTLB-loads,
perf:iTLB-load-misses, perf:branch-loads,
perf:branch-load-misses, perf:cpu-clock,

perf:task-clock, perf:page-fault,

perf:faults,

perf:major-faults, perf:minor-faults,

perf:context-switches, perf:cs,

perf:cpu-migrations, perf:migrations,
perf:alignment-faults, perf:emulation-faults

Example:
[...]
$ dmesg | grep "generic register"

$

Trying to add-context -t perf:* on such a machine fails, of course.

It would be a simple yet useful enhancement to forgo listing perf context types when none are actually possible.
History

#1 - 05/31/2013 02:20 PM - Christian Babeux

- Tracker changed from Bug to Feature

#2 - 06/02/2013 11:06 AM - David Goulet

- Status changed from New to Confirmed

#3 - 05/20/2014 11:26 AM - Christian Babeux

- Assignee set to Julien Desfossez

We should investigate the APIs that perf provides for listing available PMUs (/proc ? debugfs?).

#4 - 09/01/2015 02:40 PM - Jérémie Galarneau

- Target version set to Wishlist

#5 - 09/01/2015 02:40 PM - Jérémie Galarneau

- Assignee deleted (Julien Desfossez)
